diff --git a/gcc/ipa-prop.c b/gcc/ipa-prop.c
index f9f8e2d..e95f393 100644
--- a/gcc/ipa-prop.c
+++ b/gcc/ipa-prop.c
@@ -84,7 +84,7 @@ static alloc_pool ipa_refdesc_pool;
 static bool
 ipa_func_spec_opts_forbid_analysis_p (struct cgraph_node *node)
 {
-  tree fs_opts = DECL_FUNCTION_SPECIFIC_OPTIMIZATION (node->symbol.decl);
+  tree fs_opts = DECL_FUNCTION_SPECIFIC_OPTIMIZATION (node->decl);
   struct cl_optimization *os;
 
   if (!fs_opts)
@@ -130,7 +130,7 @@ ipa_populate_param_decls (struct cgraph_node *node,
   tree parm;
   int param_num;
 
-  fndecl = node->symbol.decl;
+  fndecl = node->decl;
   gcc_assert (gimple_has_body_p (fndecl));
   fnargs = DECL_ARGUMENTS (fndecl);
   param_num = 0;
@@ -195,7 +195,7 @@ ipa_initialize_node_params (struct cgraph_node *node)
 
   if (!info->descriptors.exists ())
     {
-      ipa_alloc_node_params (node, count_formal_params (node->symbol.decl));
+      ipa_alloc_node_params (node, count_formal_params (node->decl));
       ipa_populate_param_decls (node, info->descriptors);
     }
 }
@@ -310,16 +310,16 @@ ipa_print_node_jump_functions (FILE *f, struct cgraph_node *node)
   struct cgraph_edge *cs;
 
   fprintf (f, "  Jump functions of caller  %s/%i:\n", cgraph_node_name (node),
-	   node->symbol.order);
+	   node->order);
   for (cs = node->callees; cs; cs = cs->next_callee)
     {
       if (!ipa_edge_args_info_available_for_edge_p (cs))
 	continue;
 
       fprintf (f, "    callsite  %s/%i -> %s/%i : \n",
-	       xstrdup (cgraph_node_name (node)), node->symbol.order,
+	       xstrdup (cgraph_node_name (node)), node->order,
 	       xstrdup (cgraph_node_name (cs->callee)),
-	       cs->callee->symbol.order);
+	       cs->callee->order);
       ipa_print_node_jump_functions_for_edge (f, cs);
     }
 
@@ -1508,7 +1508,7 @@ ipa_get_callee_param_type (struct cgraph_edge *e, int i)
 {
   int n;
   tree type = (e->callee
-	       ? TREE_TYPE (e->callee->symbol.decl)
+	       ? TREE_TYPE (e->callee->decl)
 	       : gimple_call_fntype (e->call_stmt));
   tree t = TYPE_ARG_TYPES (type);
 
@@ -1522,7 +1522,7 @@ ipa_get_callee_param_type (struct cgraph_edge *e, int i)
     return TREE_VALUE (t);
   if (!e->callee)
     return NULL;
-  t = DECL_ARGUMENTS (e->callee->symbol.decl);
+  t = DECL_ARGUMENTS (e->callee->decl);
   for (n = 0; n < i; n++)
     {
       if (!t)
@@ -1640,7 +1640,7 @@ ipa_compute_jump_functions (struct cgraph_node *node,
 								  NULL);
       /* We do not need to bother analyzing calls to unknown
 	 functions unless they may become known during lto/whopr.  */
-      if (!callee->symbol.definition && !flag_lto)
+      if (!callee->definition && !flag_lto)
 	continue;
       ipa_compute_jump_functions_for_edge (parms_ainfo, cs);
     }
@@ -2049,7 +2049,7 @@ static void
 ipa_analyze_params_uses (struct cgraph_node *node,
 			 struct param_analysis_info *parms_ainfo)
 {
-  tree decl = node->symbol.decl;
+  tree decl = node->decl;
   basic_block bb;
   struct function *func;
   gimple_stmt_iterator gsi;
@@ -2079,7 +2079,7 @@ ipa_analyze_params_uses (struct cgraph_node *node,
 	 the flag during modification analysis.  */
       if (is_gimple_reg (parm))
 	{
-	  tree ddef = ssa_default_def (DECL_STRUCT_FUNCTION (node->symbol.decl),
+	  tree ddef = ssa_default_def (DECL_STRUCT_FUNCTION (node->decl),
 				       parm);
 	  if (ddef && !has_zero_uses (ddef))
 	    {
@@ -2158,7 +2158,7 @@ ipa_analyze_node (struct cgraph_node *node)
   ipa_check_create_node_params ();
   ipa_check_create_edge_args ();
   info = IPA_NODE_REF (node);
-  push_cfun (DECL_STRUCT_FUNCTION (node->symbol.decl));
+  push_cfun (DECL_STRUCT_FUNCTION (node->decl));
   ipa_initialize_node_params (node);
 
   param_count = ipa_get_param_count (info);
@@ -2406,7 +2406,7 @@ ipa_make_edge_direct_to_target (struct cgraph_edge *ie, tree target)
 	  if (dump_file)
 	    fprintf (dump_file, "ipa-prop: Discovered direct call to non-function"
 				" in %s/%i, making it unreachable.\n",
-		     cgraph_node_name (ie->caller), ie->caller->symbol.order);
+		     cgraph_node_name (ie->caller), ie->caller->order);
 	  target = builtin_decl_implicit (BUILT_IN_UNREACHABLE);
 	  callee = cgraph_get_create_node (target);
 	  unreachable = true;
@@ -2433,9 +2433,9 @@ ipa_make_edge_direct_to_target (struct cgraph_edge *ie, tree target)
 	    fprintf (dump_file, "ipa-prop: Discovered call to a known target "
 		     "(%s/%i -> %s/%i) but can not refer to it. Giving up.\n",
 		     xstrdup (cgraph_node_name (ie->caller)),
-		     ie->caller->symbol.order,
+		     ie->caller->order,
 		     xstrdup (cgraph_node_name (ie->callee)),
-		     ie->callee->symbol.order);
+		     ie->callee->order);
 	  return NULL;
 	}
       callee = cgraph_get_create_real_symbol_node (target);
@@ -2452,9 +2452,9 @@ ipa_make_edge_direct_to_target (struct cgraph_edge *ie, tree target)
 	       "(%s/%i -> %s/%i), for stmt ",
 	       ie->indirect_info->polymorphic ? "a virtual" : "an indirect",
 	       xstrdup (cgraph_node_name (ie->caller)),
-	       ie->caller->symbol.order,
+	       ie->caller->order,
 	       xstrdup (cgraph_node_name (callee)),
-	       callee->symbol.order);
+	       callee->order);
       if (ie->call_stmt)
 	print_gimple_stmt (dump_file, ie->call_stmt, 2, TDF_SLIM);
       else
@@ -2506,7 +2506,7 @@ remove_described_reference (symtab_node symbol, struct ipa_cst_ref_desc *rdesc)
   struct cgraph_edge *origin;
 
   origin = rdesc->cs;
-  to_del = ipa_find_reference ((symtab_node) origin->caller, symbol,
+  to_del = ipa_find_reference (origin->caller, symbol,
 			       origin->call_stmt, origin->lto_stmt_uid);
   if (!to_del)
     return false;
@@ -2515,7 +2515,7 @@ remove_described_reference (symtab_node symbol, struct ipa_cst_ref_desc *rdesc)
   if (dump_file)
     fprintf (dump_file, "ipa-prop: Removed a reference from %s/%i to %s.\n",
 	     xstrdup (cgraph_node_name (origin->caller)),
-	     origin->caller->symbol.order, xstrdup (symtab_node_name (symbol)));
+	     origin->caller->order, xstrdup (symtab_node_name (symbol)));
   return true;
 }
 
@@ -2563,7 +2563,7 @@ try_decrement_rdesc_refcount (struct ipa_jump_func *jfunc)
       && (rdesc = jfunc_rdesc_usable (jfunc))
       && --rdesc->refcount == 0)
     {
-      symtab_node symbol = (symtab_node) cgraph_node_for_jfunc (jfunc);
+      symtab_node symbol = cgraph_node_for_jfunc (jfunc);
       if (!symbol)
 	return false;
 
@@ -2718,7 +2718,7 @@ update_indirect_edges_after_inlining (struct cgraph_edge *cs,
 	    new_direct_edge->call_stmt_cannot_inline_p
 	      = !gimple_check_call_matching_types (
 		  new_direct_edge->call_stmt,
-		  new_direct_edge->callee->symbol.decl, false);
+		  new_direct_edge->callee->decl, false);
 	  if (new_edges)
 	    {
 	      new_edges->safe_push (new_direct_edge);
@@ -2834,15 +2834,15 @@ propagate_controlled_uses (struct cgraph_edge *cs)
 	      if (t && TREE_CODE (t) == ADDR_EXPR
 		  && TREE_CODE (TREE_OPERAND (t, 0)) == FUNCTION_DECL
 		  && (n = cgraph_get_node (TREE_OPERAND (t, 0)))
-		  && (ref = ipa_find_reference ((symtab_node) new_root,
-						(symtab_node) n, NULL, 0)))
+		  && (ref = ipa_find_reference (new_root,
+						n, NULL, 0)))
 		{
 		  if (dump_file)
 		    fprintf (dump_file, "ipa-prop: Removing cloning-created "
 			     "reference from %s/%i to %s/%i.\n",
 			     xstrdup (cgraph_node_name (new_root)),
-			     new_root->symbol.order,
-			     xstrdup (cgraph_node_name (n)), n->symbol.order);
+			     new_root->order,
+			     xstrdup (cgraph_node_name (n)), n->order);
 		  ipa_remove_reference (ref);
 		}
 	    }
@@ -2865,7 +2865,7 @@ propagate_controlled_uses (struct cgraph_edge *cs)
 		{
 		  struct cgraph_node *clone;
 		  bool ok;
-		  ok = remove_described_reference ((symtab_node) n, rdesc);
+		  ok = remove_described_reference (n, rdesc);
 		  gcc_checking_assert (ok);
 
 		  clone = cs->caller;
@@ -2874,8 +2874,8 @@ propagate_controlled_uses (struct cgraph_edge *cs)
 			 && IPA_NODE_REF (clone)->ipcp_orig_node)
 		    {
 		      struct ipa_ref *ref;
-		      ref = ipa_find_reference ((symtab_node) clone,
-						(symtab_node) n, NULL, 0);
+		      ref = ipa_find_reference (clone,
+						n, NULL, 0);
 		      if (ref)
 			{
 			  if (dump_file)
@@ -2883,9 +2883,9 @@ propagate_controlled_uses (struct cgraph_edge *cs)
 				     "cloning-created reference "
 				     "from %s/%i to %s/%i.\n",
 				     xstrdup (cgraph_node_name (clone)),
-				     clone->symbol.order,
+				     clone->order,
 				     xstrdup (cgraph_node_name (n)),
-				     n->symbol.order);
+				     n->order);
 			  ipa_remove_reference (ref);
 			}
 		      clone = clone->callers->caller;
@@ -3071,12 +3071,12 @@ ipa_edge_duplication_hook (struct cgraph_edge *src, struct cgraph_edge *dst,
 	  else if (src->caller == dst->caller)
 	    {
 	      struct ipa_ref *ref;
-	      symtab_node n = (symtab_node) cgraph_node_for_jfunc (src_jf);
+	      symtab_node n = cgraph_node_for_jfunc (src_jf);
 	      gcc_checking_assert (n);
-	      ref = ipa_find_reference ((symtab_node) src->caller, n,
+	      ref = ipa_find_reference (src->caller, n,
 					src->call_stmt, src->lto_stmt_uid);
 	      gcc_checking_assert (ref);
-	      ipa_clone_ref (ref, (symtab_node) dst->caller, ref->stmt);
+	      ipa_clone_ref (ref, dst->caller, ref->stmt);
 
 	      gcc_checking_assert (ipa_refdesc_pool);
 	      struct ipa_cst_ref_desc *dst_rdesc
@@ -3257,11 +3257,11 @@ ipa_print_node_params (FILE *f, struct cgraph_node *node)
   int i, count;
   struct ipa_node_params *info;
 
-  if (!node->symbol.definition)
+  if (!node->definition)
     return;
   info = IPA_NODE_REF (node);
   fprintf (f, "  function  %s/%i parameter descriptors:\n",
-	   cgraph_node_name (node), node->symbol.order);
+	   cgraph_node_name (node), node->order);
   count = ipa_get_param_count (info);
   for (i = 0; i < count; i++)
     {
@@ -3504,8 +3504,8 @@ ipa_modify_call_arguments (struct cgraph_edge *cs, gimple stmt,
 
   len = adjustments.length ();
   vargs.create (len);
-  callee_decl = !cs ? gimple_call_fndecl (stmt) : cs->callee->symbol.decl;
-  ipa_remove_stmt_references ((symtab_node) current_node, stmt);
+  callee_decl = !cs ? gimple_call_fndecl (stmt) : cs->callee->decl;
+  ipa_remove_stmt_references (current_node, stmt);
 
   gsi = gsi_for_stmt (stmt);
   prev_gsi = gsi;
@@ -4097,7 +4097,7 @@ ipa_write_node_info (struct output_block *ob, struct cgraph_node *node)
   struct bitpack_d bp;
 
   encoder = ob->decl_state->symtab_node_encoder;
-  node_ref = lto_symtab_encoder_encode (encoder, (symtab_node) node);
+  node_ref = lto_symtab_encoder_encode (encoder, node);
   streamer_write_uhwi (ob, node_ref);
 
   streamer_write_uhwi (ob, ipa_get_param_count (info));
@@ -4261,7 +4261,7 @@ ipa_prop_read_section (struct lto_file_decl_data *file_data, const char *data,
       index = streamer_read_uhwi (&ib_main);
       encoder = file_data->symtab_node_encoder;
       node = cgraph (lto_symtab_encoder_deref (encoder, index));
-      gcc_assert (node->symbol.definition);
+      gcc_assert (node->definition);
       ipa_read_node_info (&ib_main, node, data_in);
     }
   lto_free_section_data (file_data, LTO_section_jump_functions, NULL, data,
@@ -4313,7 +4313,7 @@ write_agg_replacement_chain (struct output_block *ob, struct cgraph_node *node)
 
   aggvals = ipa_get_agg_replacements_for_node (node);
   encoder = ob->decl_state->symtab_node_encoder;
-  node_ref = lto_symtab_encoder_encode (encoder, (symtab_node) node);
+  node_ref = lto_symtab_encoder_encode (encoder, node);
   streamer_write_uhwi (ob, node_ref);
 
   for (av = aggvals; av; av = av->next)
@@ -4437,7 +4437,7 @@ read_replacements_section (struct lto_file_decl_data *file_data,
       index = streamer_read_uhwi (&ib_main);
       encoder = file_data->symtab_node_encoder;
       node = cgraph (lto_symtab_encoder_deref (encoder, index));
-      gcc_assert (node->symbol.definition);
+      gcc_assert (node->definition);
       read_agg_replacement_chain (&ib_main, node, data_in);
     }
   lto_free_section_data (file_data, LTO_section_jump_functions, NULL, data,
@@ -4519,12 +4519,12 @@ ipcp_transform_function (struct cgraph_node *node)
 
   if (dump_file)
     fprintf (dump_file, "Modification phase of node %s/%i\n",
-	     cgraph_node_name (node), node->symbol.order);
+	     cgraph_node_name (node), node->order);
 
   aggval = ipa_get_agg_replacements_for_node (node);
   if (!aggval)
       return 0;
-  param_count = count_formal_params (node->symbol.decl);
+  param_count = count_formal_params (node->decl);
   if (param_count == 0)
     return 0;
   adjust_agg_replacement_values (node, aggval);
diff --git a/gcc/ipa-pure-const.c b/gcc/ipa-pure-const.c
index ed4deae..721272f 100644
--- a/gcc/ipa-pure-const.c
+++ b/gcc/ipa-pure-const.c
@@ -725,7 +725,7 @@ check_stmt (gimple_stmt_iterator *gsip, funct_state local, bool ipa)
 static funct_state
 analyze_function (struct cgraph_node *fn, bool ipa)
 {
-  tree decl = fn->symbol.decl;
+  tree decl = fn->decl;
   funct_state l;
   basic_block this_block;
 
@@ -736,10 +736,10 @@ analyze_function (struct cgraph_node *fn, bool ipa)
   l->looping = false;
   l->can_throw = false;
   state_from_flags (&l->state_previously_known, &l->looping_previously_known,
-		    flags_from_decl_or_type (fn->symbol.decl),
+		    flags_from_decl_or_type (fn->decl),
 		    cgraph_node_cannot_return (fn));
 
-  if (fn->thunk.thunk_p || fn->symbol.alias)
+  if (fn->thunk.thunk_p || fn->alias)
     {
       /* Thunk gets propagated through, so nothing interesting happens.  */
       gcc_assert (ipa);
@@ -952,7 +952,7 @@ pure_const_write_summary (void)
        lsei_next_function_in_partition (&lsei))
     {
       node = lsei_cgraph_node (lsei);
-      if (node->symbol.definition && has_function_state (node))
+      if (node->definition && has_function_state (node))
 	count++;
     }
 
@@ -963,7 +963,7 @@ pure_const_write_summary (void)
        lsei_next_function_in_partition (&lsei))
     {
       node = lsei_cgraph_node (lsei);
-      if (node->symbol.definition && has_function_state (node))
+      if (node->definition && has_function_state (node))
 	{
 	  struct bitpack_d bp;
 	  funct_state fs;
@@ -973,7 +973,7 @@ pure_const_write_summary (void)
 	  fs = get_function_state (node);
 
 	  encoder = ob->decl_state->symtab_node_encoder;
-	  node_ref = lto_symtab_encoder_encode (encoder, (symtab_node)node);
+	  node_ref = lto_symtab_encoder_encode (encoder, node);
 	  streamer_write_uhwi_stream (ob->main_stream, node_ref);
 
 	  /* Note that flags will need to be read in the opposite
@@ -1042,10 +1042,10 @@ pure_const_read_summary (void)
 	      fs->can_throw = bp_unpack_value (&bp, 1);
 	      if (dump_file)
 		{
-		  int flags = flags_from_decl_or_type (node->symbol.decl);
+		  int flags = flags_from_decl_or_type (node->decl);
 		  fprintf (dump_file, "Read info for %s/%i ",
 			   cgraph_node_name (node),
-			   node->symbol.order);
+			   node->order);
 		  if (flags & ECF_CONST)
 		    fprintf (dump_file, " const");
 		  if (flags & ECF_PURE)
@@ -1126,7 +1126,7 @@ propagate_pure_const (void)
       int count = 0;
       node = order[i];
 
-      if (node->symbol.alias)
+      if (node->alias)
 	continue;
 
       if (dump_file && (dump_flags & TDF_DETAILS))
@@ -1145,7 +1145,7 @@ propagate_pure_const (void)
 	  if (dump_file && (dump_flags & TDF_DETAILS))
 	    fprintf (dump_file, "  Visiting %s/%i state:%s looping %i\n",
 		     cgraph_node_name (w),
-		     w->symbol.order,
+		     w->order,
 		     pure_const_names[w_l->pure_const_state],
 		     w_l->looping);
 
@@ -1192,7 +1192,7 @@ propagate_pure_const (void)
 		  fprintf (dump_file,
 			   "    Call to %s/%i",
 			   cgraph_node_name (e->callee),
-			   e->callee->symbol.order);
+			   e->callee->order);
 		}
 	      if (avail > AVAIL_OVERWRITABLE)
 		{
@@ -1221,11 +1221,11 @@ propagate_pure_const (void)
 		    }
 		}
 	      else if (special_builtin_state (&edge_state, &edge_looping,
-					       y->symbol.decl))
+					       y->decl))
 		;
 	      else
 		state_from_flags (&edge_state, &edge_looping,
-				  flags_from_decl_or_type (y->symbol.decl),
+				  flags_from_decl_or_type (y->decl),
 				  cgraph_edge_cannot_lead_to_return (e));
 
 	      /* Merge the results with what we already know.  */
@@ -1264,7 +1264,7 @@ propagate_pure_const (void)
 	    break;
 
 	  /* And finally all loads and stores.  */
-	  for (i = 0; ipa_ref_list_reference_iterate (&w->symbol.ref_list, i, ref); i++)
+	  for (i = 0; ipa_ref_list_reference_iterate (&w->ref_list, i, ref); i++)
 	    {
 	      enum pure_const_state_e ref_state = IPA_CONST;
 	      bool ref_looping = false;
@@ -1272,7 +1272,7 @@ propagate_pure_const (void)
 		{
 		case IPA_REF_LOAD:
 		  /* readonly reads are safe.  */
-		  if (TREE_READONLY (ipa_ref_varpool_node (ref)->symbol.decl))
+		  if (TREE_READONLY (ipa_ref_varpool_node (ref)->decl))
 		    break;
 		  if (dump_file && (dump_flags & TDF_DETAILS))
 		    fprintf (dump_file, "    nonreadonly global var read\n");
@@ -1296,7 +1296,7 @@ propagate_pure_const (void)
 	      if (pure_const_state == IPA_NEITHER)
 		break;
 	    }
-	  w_info = (struct ipa_dfs_info *) w->symbol.aux;
+	  w_info = (struct ipa_dfs_info *) w->aux;
 	  w = w_info->next_cycle;
 	}
       if (dump_file && (dump_flags & TDF_DETAILS))
@@ -1331,9 +1331,9 @@ propagate_pure_const (void)
 	  switch (this_state)
 	    {
 	    case IPA_CONST:
-	      if (!TREE_READONLY (w->symbol.decl))
+	      if (!TREE_READONLY (w->decl))
 		{
-		  warn_function_const (w->symbol.decl, !this_looping);
+		  warn_function_const (w->decl, !this_looping);
 		  if (dump_file)
 		    fprintf (dump_file, "Function found to be %sconst: %s\n",
 			     this_looping ? "looping " : "",
@@ -1343,9 +1343,9 @@ propagate_pure_const (void)
 	      break;
 
 	    case IPA_PURE:
-	      if (!DECL_PURE_P (w->symbol.decl))
+	      if (!DECL_PURE_P (w->decl))
 		{
-		  warn_function_pure (w->symbol.decl, !this_looping);
+		  warn_function_pure (w->decl, !this_looping);
 		  if (dump_file)
 		    fprintf (dump_file, "Function found to be %spure: %s\n",
 			     this_looping ? "looping " : "",
@@ -1357,7 +1357,7 @@ propagate_pure_const (void)
 	    default:
 	      break;
 	    }
-	  w_info = (struct ipa_dfs_info *) w->symbol.aux;
+	  w_info = (struct ipa_dfs_info *) w->aux;
 	  w = w_info->next_cycle;
 	}
     }
@@ -1396,7 +1396,7 @@ propagate_nothrow (void)
       bool can_throw = false;
       node = order[i];
 
-      if (node->symbol.alias)
+      if (node->alias)
 	continue;
 
       /* Find the worst state for any node in the cycle.  */
@@ -1424,11 +1424,11 @@ propagate_nothrow (void)
 
 		  if (can_throw)
 		    break;
-		  if (y_l->can_throw && !TREE_NOTHROW (w->symbol.decl)
+		  if (y_l->can_throw && !TREE_NOTHROW (w->decl)
 		      && e->can_throw_external)
 		    can_throw = true;
 		}
-	      else if (e->can_throw_external && !TREE_NOTHROW (y->symbol.decl))
+	      else if (e->can_throw_external && !TREE_NOTHROW (y->decl))
 	        can_throw = true;
 	    }
           for (ie = node->indirect_calls; ie; ie = ie->next_callee)
@@ -1437,7 +1437,7 @@ propagate_nothrow (void)
 		can_throw = true;
 		break;
 	      }
-	  w_info = (struct ipa_dfs_info *) w->symbol.aux;
+	  w_info = (struct ipa_dfs_info *) w->aux;
 	  w = w_info->next_cycle;
 	}
 
@@ -1447,16 +1447,16 @@ propagate_nothrow (void)
       while (w)
 	{
 	  funct_state w_l = get_function_state (w);
-	  if (!can_throw && !TREE_NOTHROW (w->symbol.decl))
+	  if (!can_throw && !TREE_NOTHROW (w->decl))
 	    {
 	      cgraph_set_nothrow_flag (w, true);
 	      if (dump_file)
 		fprintf (dump_file, "Function found to be nothrow: %s\n",
 			 cgraph_node_name (w));
 	    }
-	  else if (can_throw && !TREE_NOTHROW (w->symbol.decl))
+	  else if (can_throw && !TREE_NOTHROW (w->decl))
 	    w_l->can_throw = true;
-	  w_info = (struct ipa_dfs_info *) w->symbol.aux;
+	  w_info = (struct ipa_dfs_info *) w->aux;
 	  w = w_info->next_cycle;
 	}
     }
diff --git a/gcc/ipa-ref-inline.h b/gcc/ipa-ref-inline.h
index bb74f87..4bb43c2 100644
--- a/gcc/ipa-ref-inline.h
+++ b/gcc/ipa-ref-inline.h
@@ -54,7 +54,7 @@ ipa_ref_referring_varpool_node (struct ipa_ref *ref)
 static inline struct ipa_ref_list *
 ipa_ref_referring_ref_list (struct ipa_ref *ref)
 {
-  return &ref->referring->symbol.ref_list;
+  return &ref->referring->ref_list;
 }
 
 /* Return reference list REF is in.  */
@@ -62,7 +62,7 @@ ipa_ref_referring_ref_list (struct ipa_ref *ref)
 static inline struct ipa_ref_list *
 ipa_ref_referred_ref_list (struct ipa_ref *ref)
 {
-  return &ref->referred->symbol.ref_list;
+  return &ref->referred->ref_list;
 }
 
 /* Return first reference in LIST or NULL if empty.  */
diff --git a/gcc/ipa-ref.c b/gcc/ipa-ref.c
index a7c3b40..4f04614e 100644
--- a/gcc/ipa-ref.c
+++ b/gcc/ipa-ref.c
@@ -45,12 +45,12 @@ ipa_record_reference (symtab_node referring_node,
   gcc_checking_assert (!stmt || is_a <cgraph_node> (referring_node));
   gcc_checking_assert (use_type != IPA_REF_ALIAS || !stmt);
 
-  list = &referring_node->symbol.ref_list;
+  list = &referring_node->ref_list;
   old_references = vec_safe_address (list->references);
   vec_safe_grow (list->references, vec_safe_length (list->references) + 1);
   ref = &list->references->last ();
 
-  list2 = &referred_node->symbol.ref_list;
+  list2 = &referred_node->ref_list;
   list2->referring.safe_push (ref);
   ref->referred_index = list2->referring.length () - 1;
   ref->referring = referring_node;
@@ -155,7 +155,7 @@ ipa_dump_references (FILE * file, struct ipa_ref_list *list)
     {
       fprintf (file, "%s/%i (%s)",
                symtab_node_asm_name (ref->referred),
-               ref->referred->symbol.order,
+               ref->referred->order,
 	       ipa_ref_use_name [ref->use]);
       if (ref->speculative)
 	fprintf (file, " (speculative)");
@@ -174,7 +174,7 @@ ipa_dump_referring (FILE * file, struct ipa_ref_list *list)
     {
       fprintf (file, "%s/%i (%s)",
                symtab_node_asm_name (ref->referring),
-               ref->referring->symbol.order,
+               ref->referring->order,
 	       ipa_ref_use_name [ref->use]);
       if (ref->speculative)
 	fprintf (file, " (speculative)");
@@ -274,7 +274,7 @@ ipa_find_reference (symtab_node referring_node, symtab_node referred_node,
   struct ipa_ref *r = NULL;
   int i;
 
-  for (i = 0; ipa_ref_list_reference_iterate (&referring_node->symbol.ref_list, i, r); i++)
+  for (i = 0; ipa_ref_list_reference_iterate (&referring_node->ref_list, i, r); i++)
     if (r->referred == referred_node
 	&& !r->speculative
 	&& ((stmt && r->stmt == stmt)
@@ -293,7 +293,7 @@ ipa_remove_stmt_references (symtab_node referring_node, gimple stmt)
   struct ipa_ref *r = NULL;
   int i;
 
-  for (i = 0; ipa_ref_list_reference_iterate (&referring_node->symbol.ref_list, i, r); i++)
+  for (i = 0; ipa_ref_list_reference_iterate (&referring_node->ref_list, i, r); i++)
     if (r->stmt == stmt)
       ipa_remove_reference (r);
 }
@@ -309,7 +309,7 @@ ipa_clear_stmts_in_references (symtab_node referring_node)
   struct ipa_ref *r = NULL;
   int i;
 
-  for (i = 0; ipa_ref_list_reference_iterate (&referring_node->symbol.ref_list, i, r); i++)
+  for (i = 0; ipa_ref_list_reference_iterate (&referring_node->ref_list, i, r); i++)
     if (!r->speculative)
       {
 	r->stmt = NULL;
diff --git a/gcc/ipa-reference.c b/gcc/ipa-reference.c
index 3742474..9c54921 100644
--- a/gcc/ipa-reference.c
+++ b/gcc/ipa-reference.c
@@ -180,7 +180,7 @@ ipa_reference_get_not_read_global (struct cgraph_node *fn)
     get_reference_optimization_summary (cgraph_function_node (fn, NULL));
   if (info)
     return info->statics_not_read;
-  else if (flags_from_decl_or_type (fn->symbol.decl) & ECF_LEAF)
+  else if (flags_from_decl_or_type (fn->decl) & ECF_LEAF)
     return all_module_statics;
   else
     return NULL;
@@ -198,7 +198,7 @@ ipa_reference_get_not_written_global (struct cgraph_node *fn)
     get_reference_optimization_summary (fn);
   if (info)
     return info->statics_not_written;
-  else if (flags_from_decl_or_type (fn->symbol.decl) & ECF_LEAF)
+  else if (flags_from_decl_or_type (fn->decl) & ECF_LEAF)
     return all_module_statics;
   else
     return NULL;
@@ -367,7 +367,7 @@ propagate_bits (ipa_reference_global_vars_info_t x_global, struct cgraph_node *x
 	continue;
 
       /* Only look into nodes we can propagate something.  */
-      int flags = flags_from_decl_or_type (y->symbol.decl);
+      int flags = flags_from_decl_or_type (y->decl);
       if (avail > AVAIL_OVERWRITABLE
 	  || (avail == AVAIL_OVERWRITABLE && (flags & ECF_LEAF)))
 	{
@@ -462,11 +462,11 @@ analyze_function (struct cgraph_node *fn)
   tree var;
 
   local = init_function_info (fn);
-  for (i = 0; ipa_ref_list_reference_iterate (&fn->symbol.ref_list, i, ref); i++)
+  for (i = 0; ipa_ref_list_reference_iterate (&fn->ref_list, i, ref); i++)
     {
       if (!is_a <varpool_node> (ref->referred))
 	continue;
-      var = ipa_ref_varpool_node (ref)->symbol.decl;
+      var = ipa_ref_varpool_node (ref)->decl;
       if (!is_proper_for_analysis (var))
 	continue;
       switch (ref->use)
@@ -564,7 +564,7 @@ generate_summary (void)
 	  l = &get_reference_vars_info (node)->local;
 	  fprintf (dump_file,
 		   "\nFunction name:%s/%i:",
-		   cgraph_node_asm_name (node), node->symbol.order);
+		   cgraph_node_asm_name (node), node->order);
 	  fprintf (dump_file, "\n  locals read: ");
 	  if (l->statics_read)
 	    EXECUTE_IF_SET_IN_BITMAP (l->statics_read,
@@ -590,7 +590,7 @@ static void
 read_write_all_from_decl (struct cgraph_node *node,
 			  bool &read_all, bool &write_all)
 {
-  tree decl = node->symbol.decl;
+  tree decl = node->decl;
   int flags = flags_from_decl_or_type (decl);
   if ((flags & ECF_LEAF)
       && cgraph_function_body_availability (node) <= AVAIL_OVERWRITABLE)
@@ -603,7 +603,7 @@ read_write_all_from_decl (struct cgraph_node *node,
       read_all = true;
       if (dump_file && (dump_flags & TDF_DETAILS))
          fprintf (dump_file, "   %s/%i -> read all\n",
-		  cgraph_node_asm_name (node), node->symbol.order);
+		  cgraph_node_asm_name (node), node->order);
     }
   else
     {
@@ -613,7 +613,7 @@ read_write_all_from_decl (struct cgraph_node *node,
       write_all = true;
       if (dump_file && (dump_flags & TDF_DETAILS))
          fprintf (dump_file, "   %s/%i -> read all, write all\n",
-		  cgraph_node_asm_name (node), node->symbol.order);
+		  cgraph_node_asm_name (node), node->order);
     }
 }
 
@@ -680,12 +680,12 @@ propagate (void)
 
   /* Now we know what vars are really statics; prune out those that aren't.  */
   FOR_EACH_VARIABLE (vnode)
-    if (vnode->symbol.externally_visible
-	|| TREE_ADDRESSABLE (vnode->symbol.decl)
-	|| TREE_READONLY (vnode->symbol.decl)
-	|| !is_proper_for_analysis (vnode->symbol.decl)
-	|| !vnode->symbol.definition)
-      bitmap_clear_bit (all_module_statics, DECL_UID (vnode->symbol.decl));
+    if (vnode->externally_visible
+	|| TREE_ADDRESSABLE (vnode->decl)
+	|| TREE_READONLY (vnode->decl)
+	|| !is_proper_for_analysis (vnode->decl)
+	|| !vnode->definition)
+      bitmap_clear_bit (all_module_statics, DECL_UID (vnode->decl));
 
   /* Forget info we collected "just for fun" on variables that turned out to be
      non-local.  */
@@ -716,7 +716,7 @@ propagate (void)
       bool write_all = false;
 
       node = order[i];
-      if (node->symbol.alias)
+      if (node->alias)
 	continue;
 
       node_info = get_reference_vars_info (node);
@@ -726,7 +726,7 @@ propagate (void)
 
       if (dump_file && (dump_flags & TDF_DETAILS))
 	fprintf (dump_file, "Starting cycle with %s/%i\n",
-		  cgraph_node_asm_name (node), node->symbol.order);
+		  cgraph_node_asm_name (node), node->order);
 
       vec<cgraph_node_ptr> cycle_nodes = ipa_get_nodes_in_cycle (node);
 
@@ -735,7 +735,7 @@ propagate (void)
 	{
 	  if (dump_file && (dump_flags & TDF_DETAILS))
 	    fprintf (dump_file, "  Visiting %s/%i\n",
-		     cgraph_node_asm_name (w), w->symbol.order);
+		     cgraph_node_asm_name (w), w->order);
 	  get_read_write_all_from_node (w, read_all, write_all);
 	  if (read_all && write_all)
 	    break;
@@ -762,7 +762,7 @@ propagate (void)
 	    {
 	      ipa_reference_vars_info_t w_ri = get_reference_vars_info (w);
 	      ipa_reference_local_vars_info_t w_l = &w_ri->local;
-	      int flags = flags_from_decl_or_type (w->symbol.decl);
+	      int flags = flags_from_decl_or_type (w->decl);
 
 	      if (!(flags & ECF_CONST))
 		read_all = union_static_var_sets (node_g->statics_read,
@@ -794,12 +794,12 @@ propagate (void)
 	  struct cgraph_node *w;
 
 	  node = order[i];
-	  if (node->symbol.alias)
+	  if (node->alias)
 	    continue;
 
 	  fprintf (dump_file,
 		   "\nFunction name:%s/%i:",
-		   cgraph_node_asm_name (node), node->symbol.order);
+		   cgraph_node_asm_name (node), node->order);
 
 	  ipa_reference_vars_info_t node_info = get_reference_vars_info (node);
 	  ipa_reference_global_vars_info_t node_g = &node_info->global;
@@ -811,7 +811,7 @@ propagate (void)
 	      ipa_reference_local_vars_info_t w_l = &w_ri->local;
 	      if (w != node)
 		fprintf (dump_file, "\n  next cycle: %s/%i ",
-			 cgraph_node_asm_name (w), w->symbol.order);
+			 cgraph_node_asm_name (w), w->order);
 	      fprintf (dump_file, "\n    locals read: ");
 	      dump_static_vars_set_to_file (dump_file, w_l->statics_read);
 	      fprintf (dump_file, "\n    locals written: ");
@@ -835,9 +835,9 @@ propagate (void)
       ipa_reference_optimization_summary_t opt;
 
       node_info = get_reference_vars_info (node);
-      if (!node->symbol.alias
+      if (!node->alias
 	  && (cgraph_function_body_availability (node) > AVAIL_OVERWRITABLE
-	      || (flags_from_decl_or_type (node->symbol.decl) & ECF_LEAF)))
+	      || (flags_from_decl_or_type (node->decl) & ECF_LEAF)))
 	{
 	  node_g = &node_info->global;
 
@@ -894,7 +894,7 @@ write_node_summary_p (struct cgraph_node *node,
   ipa_reference_optimization_summary_t info;
 
   /* See if we have (non-empty) info.  */
-  if (!node->symbol.definition || node->global.inlined_to)
+  if (!node->definition || node->global.inlined_to)
     return false;
   info = get_reference_optimization_summary (node);
   if (!info || (bitmap_empty_p (info->statics_not_read)
@@ -908,7 +908,7 @@ write_node_summary_p (struct cgraph_node *node,
      In future we might also want to include summaries of functions references
      by initializers of constant variables references in current unit.  */
   if (!reachable_from_this_partition_p (node, encoder)
-      && !referenced_from_this_partition_p (&node->symbol.ref_list, encoder))
+      && !referenced_from_this_partition_p (&node->ref_list, encoder))
     return false;
 
   /* See if the info has non-empty intersections with vars we want to encode.  */
@@ -974,10 +974,10 @@ ipa_reference_write_optimization_summary (void)
       symtab_node snode = lto_symtab_encoder_deref (encoder, i);
       varpool_node *vnode = dyn_cast <varpool_node> (snode);
       if (vnode
-	  && bitmap_bit_p (all_module_statics, DECL_UID (vnode->symbol.decl))
-	  && referenced_from_this_partition_p (&vnode->symbol.ref_list, encoder))
+	  && bitmap_bit_p (all_module_statics, DECL_UID (vnode->decl))
+	  && referenced_from_this_partition_p (&vnode->ref_list, encoder))
 	{
-	  tree decl = vnode->symbol.decl;
+	  tree decl = vnode->decl;
 	  bitmap_set_bit (ltrans_statics, DECL_UID (decl));
 	  splay_tree_insert (reference_vars_to_consider,
 			     DECL_UID (decl), (splay_tree_value)decl);
@@ -1089,7 +1089,7 @@ ipa_reference_read_optimization_summary (void)
 	      if (dump_file)
 		fprintf (dump_file,
 			 "\nFunction name:%s/%i:\n  static not read:",
-			 cgraph_node_asm_name (node), node->symbol.order);
+			 cgraph_node_asm_name (node), node->order);
 
 	      /* Set the statics not read.  */
 	      v_count = streamer_read_hwi (ib);
